#!/usr/bin/env python
#/***************************************************************************
# *   Copyright (C) 2008 by Paul Hardwick                                   *
# *   paul@peck.org.uk                                                      *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
# ***************************************************************************/
#nudge.....................

"HSOconnect - an application to control an internet connection using Option 3G devices and the HSO driver"
__rev__ = "$Revision: 11 $"[10:-1].strip()
__version__ = "1.2."+__rev__
__author__ = "Paul Hardwick <paul@peck.org.uk>"
__date__ =  "$Date: 2009-05-24 16:46:58 +0100 (Sun, 24 May 2009) $"[6:18].strip()

    
def run():
    import os, sys
    import HSOconsole
    if  os.environ.get("HSOCONF",False): 
         PIDPATH = os.environ["HSOCONF"]
    else:
        PIDPATH ="/usr/share/hsoconnect/hsoconf"
    if os.path.isfile(os.path.join(PIDPATH, 'pid')):
        fpid = open(os.path.join(PIDPATH, 'pid'), 'r')
        pid = int(fpid.readline().strip())
        fpid.close()
        if pid > 0:
            try:
                os.kill(pid, 0) #if it does not exist exception raised
                sys.stderr.write("There is already a running instance of HSOconnect\n")
                sys.exit(1)
            except os.error, args:
                pass #carry on and start HSOconnect
    fpid = open(os.path.join(PIDPATH, 'pid'), 'w')
    fpid.write("%d" % os.getpid())
    fpid.close()
    #os.chmod(os.path.join(PIDPATH, 'pid'), 0666)
    HSOconsole.run()
    os.remove(os.path.join(PIDPATH, 'pid'))              
    sys.exit(0)

if __name__ == "__main__":
    run()
