#/***************************************************************************
# *   Copyright (C) 2008 by Paul Hardwick                                   *
# *   paul@peck.org.uk                                                      *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
# ***************************************************************************/

_rev = "$Revision: 6 $"[10:-1].strip()
__version__ = "1.2."+_rev
__author__ = "Paul Hardwick <paul@peck.org.uk>"
__date__ = "$Date: 2009-05-24 09:12:11 +0100 (Sun, 24 May 2009) $"[6:18].strip()

#Profile name dialog

import pygtk
pygtk.require('2.0')
import gtk
import re

def ErrorDialog(parent, title,msg):
    #display an error
    msgbox = gtk.MessageDialog(parent, buttons = gtk.BUTTONS_OK, flags = gtk.DIALOG_MODAL,
                                type= gtk.MESSAGE_ERROR, message_format = msg)
    msgbox.set_title(title)
    msgbox.run()
    msgbox.destroy()
    
def validateProfile(profile):
    if re.match("^[a-zA-Z0-9._-]+$", profile) != None:
        return 1
    return 0

def ProfileDialog(window,title_text="New Profile Name",prompt_text = "Enter:"):
    dialog = gtk.Dialog(title=title_text, parent = window,
                        flags = gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                        buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))

    entry = gtk.Entry()
    entry.set_max_length(30)
    entry.set_width_chars(30)
    entry.set_visibility(True)
    entry.connect("activate", lambda *args: dialog.response(gtk.RESPONSE_ACCEPT))
    Hbox = gtk.HBox(False, 5)
    Hbox.pack_start(gtk.Label(prompt_text))
    Hbox.pack_start(entry)
    dialog.vbox.pack_start(Hbox)
    dialog.show_all()
    response = dialog.run()
    dialog.hide()
    if response == gtk.RESPONSE_ACCEPT:
        return entry.get_text()
    else:
        return ''

def runProfile(window,title_text,prompt_text, strings):
    profile = ''
    while True:
        profile = ProfileDialog(window,title_text,prompt_text).strip()
        valid = True
        if profile == '' : return '' #User cancelled
        else:
            valid = validateProfile(profile)
            if not valid:
                ErrorDialog(window, strings['error'],strings['error_profile_name'])
##            for n in pin:
##                if n not in "1234567890":
##                    valid = False
##                    ErrorDialog(window, strings['error'],strings['error_pin_nonnumber'])
##                    #non number detected
##                    break
            if valid: break
    return profile
    
