#/***************************************************************************
# *   Copyright (C) 2008 by Paul Hardwick                                   *
# *   paul@peck.org.uk                                                      *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
# ***************************************************************************/

_rev = "$Revision: 6 $"[10:-1].strip()
__version__ = "1.2."+_rev
__author__ = "Paul Hardwick <paul@peck.org.uk>"
__date__ = "$Date: 2009-05-24 09:12:11 +0100 (Sun, 24 May 2009) $"[6:18].strip()

#General Pick from a list dialog

import pygtk
pygtk.require('2.0')
import gtk

class RadioDialog3column:

    def callback(self, widget, data=None):
        self.item = data
           

    def __init__(self,window, title_text, buttons, default):
        self.dialog = gtk.Dialog(title=title_text, parent = window,
                            flags = gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                            buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))

        self.item=None
        box2 = gtk.VBox(False, 0)
        box2.set_border_width(20)
        box2.show()
        button = None
        hbox = gtk.Table(len(buttons)+1,3)
        hbox.set_col_spacing(0, 3)
        hbox.set_col_spacing(1, 3)

        for n in range(len(buttons)):
            
            button = gtk.RadioButton(button, buttons[n][0])
            button.connect("toggled", self.callback, str(n))
            if n == int(default): button.set_active(True)
            button.show()  
            hbox.attach(button, 0,1,0+n,1+n)
            lab = gtk.Label(buttons[n][1])
            lab.show()
            hbox.attach(lab, 1,2,n+0,n+1)
            lab2 = gtk.Label(buttons[n][2])
            lab2.show()
            hbox.attach(lab2, 2,3,n+0,n+1)
            hbox.show()
        #Create hidden Radiobutton for when no item selected
        hiddenbutton = gtk.RadioButton(button, 'dummy')
        if int(default) == -1: hiddenbutton.set_active(True)
        box2.pack_start(hbox, True, True, 0)
     
        self.dialog.vbox.pack_start(box2)


    def run(self):
        self.dialog.show_all()
        response = self.dialog.run()
        self.dialog.hide()
        if response == gtk.RESPONSE_ACCEPT:
            if response == -1: return None #OK with no selection - hidden selection - no change
            return int(self.item)
        else:
            return None #user canceled - no change
        




    
